import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class Chat extends Frame implements WindowListener 
{

 Panel act = new Panel();
 public static OptionField optionField = new OptionField();
 ChatSender chats = new ChatSender();
 public static TextArea chatField = new TextArea();
 int port = Defaults.chatPort;
 ServerSocket sSock;
 Socket sock;
 static boolean reader = true;
 InputStream in;
 boolean first = true;
 ObjectInputStream sIn;
 ChatMenuBar cmb = new ChatMenuBar();
 public static String title = "JChat V2.2";

public Chat()
{
System.out.println("\nStarting init...");
 setSize(550,350);
 setLocation(66,66);
 setLayout(new BorderLayout(2,2));
 setBackground(Defaults.backC);
 setForeground(Defaults.frontC);
 setTitle(title);

System.out.println("Starting just-in-time-compiler...");

 Compiler.enable();
 Compiler.compileClasses("About.class");
 Compiler.compileClasses("Chat.class");
 Compiler.compileClasses("ChatMenuBar.class");
 Compiler.compileClasses("ChatSender.class");
 Compiler.compileClasses("ColorMenu.class");
 Compiler.compileClasses("Defaults.class");
 Compiler.compileClasses("GetIp.class");
 Compiler.compileClasses("InputProcessor.class");
 Compiler.compileClasses("OptionField.class");
 Compiler.compileClasses("Settings.class");

 chatField.setBackground(Defaults.textFieldC);

 add("North", chats);
 add("Center", chatField);
 add("East", optionField);

 addWindowListener(this);

System.out.println("Adding MenuBar...");
setMenuBar(cmb);

Image icon = Toolkit.getDefaultToolkit().getImage("icon.gif");
setIconImage(icon);

setResizable(Defaults.chatResize);

validate();
setVisible(true);

chats.startIt();

System.out.println("Finished...\n");

recieveData();

}

void recieveData()
{

try
{
sSock = new ServerSocket(port);
sock = sSock.accept();
in = sock.getInputStream();
sIn = new ObjectInputStream(in);
}
catch(Exception ex) {System.out.println(ex);}

Color col = new Color(0,0,0);
String options = "private";
String sender = "Alcoholic";
String style = "says";
String s = "Error";

try
{
 col = (Color) sIn.readObject();
 chatField.setForeground(col);
 options = (String) sIn.readObject();
 sender = (String) sIn.readObject();
 style = (String) sIn.readObject(); 

s = (String) sIn.readObject();
}
catch(Exception ex) {System.out.println("Error in data-format - check version!");}

try {InputProcessor inputProcessor = new 
     InputProcessor(sender, options, style, s);
}  
catch(Exception ex) {System.out.println("Error in processing Input");}

try
{
in.close();
sIn.close();
sock.close();
sSock.close();
}
catch(Exception ex) {System.out.println("Socket-Exception!");}

recieveData();
   
}

public void windowClosing(WindowEvent e) {System.exit(0);}
public void windowClosed(WindowEvent e) {}
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}

public static void main(String argv[])
{
 Chat chat = new Chat();
}

public Insets getInsets() 
{ 
Insets in = super.getInsets();
return new Insets(in.top+5,in.left+5,in.bottom+5,in.right+5); 
}

}
